#Include-once
Func _ArraySearchAnyDim(Const ByRef $avArray, $vWhat2Find, $iStart = 0, $iEnd = 0, $iCaseSense = 0, $sDimString = "[x]")
	Local $iCurrentPos, $iUBound, $iSub = 1
	$iLen = StringLen($sDimString)
	If $sDimString <> "[x]" Then
		If Not IsInt($iLen / 3) Then
			SetError(7)
			Return -1
		EndIf
		For $iCounter = 1 To $iLen Step 3
			$sPart = StringMid($sDimString, $iCounter, 3)
			If StringMid($sPart, 1, 1) <> "[" Then
				SetError(7)
				Return -1
			EndIf
			If Not (StringMid($sPart, 2, 1) = "x" Or StringIsInt(StringMid($sPart, 2, 1))) Then
				SetError(7)
				Return -1
			EndIf
			If StringMid($sPart, 3, 1) <> "]" Then
				SetError(7)
				Return -1
			EndIf
			StringReplace($sDimString, "x", "")
			If @extended <> 1 Then
				SetError(7)
				Return -1
			EndIf
			$iPos = StringInStr($sDimString, "x")
			$iSub= ($iPos + 1) / 3
		Next
	EndIf
	If Not IsArray($avArray) Then
		SetError(1)
		Return -1
	EndIf
	$iUBound = UBound($avArray, $iSub) - 1
	If $iEnd = 0 Then $iEnd = $iUBound
	If $iStart > $iUBound Then
		SetError(2)
		Return -1
	EndIf
	If $iEnd > $iUBound Then
		SetError(3)
		Return -1
	EndIf
	If $iStart > $iEnd Then
		SetError(4)
		Return -1
	EndIf
	If Not ($iCaseSense = 0 Or $iCaseSense = 1) Then
		SetError(5)
		Return -1
	EndIf
	For $iCurrentPos = $iStart To $iEnd
		$sDimString2 = StringReplace($sDimString, "x", $iCurrentPos)
		Select
			Case $iCaseSense = 0
				If Execute("$avArray" & $sDimString2) = $vWhat2Find Then
					SetError(0)
					Return $iCurrentPos
				EndIf
			Case $iCaseSense = 1
				If Execute("$avArray" & $sDimString2) == $vWhat2Find Then
					SetError(0)
					Return $iCurrentPos
				EndIf
		EndSelect
	Next
	SetError(6)
	Return -1
EndFunc   ;==>_ArraySearchAnyDim